unit fileunit;

interface

uses dos;

type
	message = string[60];

var
	name: namestr;
	file_done: Boolean;

procedure get_file_name(prompt : message; var name : pathstr);
procedure test_error(var fname : PathStr);
procedure file_input(mess : PathStr; var GG : text);
procedure file_output(mess : PathStr; var GG : text);
procedure file_copy(file_src, file_dest : PathStr; OverWrite : Boolean);
procedure file_merge(file_src,file_dest : PathStr);
procedure file_delete(file_dest : PathStr);
procedure file_rename(file_src, file_dest : PathStr; OverWrite : Boolean);

function file_exist_check(Name : PathStr):Boolean;
function get_file_extension(S : PathStr):String;
function get_file_prefix(S : PathStr):String;
function get_file_dir(S : PathStr):String;

implementation

{$I+}
procedure get_file_name(prompt: message; var name: PathStr);
begin
	WriteLn(prompt);
	ReadLn(name);
	name := FExpand(name);
end;

procedure test_error(var fname: PathStr);
var 
	n: integer;
	messg: message;
begin
		case IOResult of
			0: Exit;
			2: messg := '  ';
			3: messg := '  ';
			4: messg := '  15 䠩';
			5: begin
				writeln('  ᫥ 訡:');
				writeln(' ⪠   䠩,  ⮫쪮  ⥭');
				writeln('   㪠  ');
				writeln(' ⪠ १ 䠩, ⮣ ⮫쪮  ⥭');
				writeln(' ⪠ 㤠 ⠫  䠩, ⮣ ⮫쪮  					⥭');
				writeln(' ⠫  㪠  ');
				messg := '  /뢮   ';
			end;
			6: messg := ' ०';
			8: messg := '筮 ';
			12: messg := 'ࠢ ⨯ 䠩';
			15: messg := 'ࠢ쭮 ன⢮';
			16: messg := ' ⥪饣 ⠫';
			17: messg := '⪠ ७ 䠩  㣮 ன⢮';
			100: messg := '⪠ ⥭ ᫥ ਧ  䠩 ' + fname;
			101: messg := '   ᪥';
			102: messg := fname + '   祭';
			103..105: messg := fname + '   ';
			106: messg := '訡  ᫮ 祭';
		end;
		writeln(' ', fname, '    ࠡ⠭');
		writeln(messg);
		write(' <Enter>  ४饭 ࠡ ணࠬ');
		readln;
		halt;

end;

procedure file_input(mess: PathStr; var GG: text);
begin
	assign(GG, mess);
	{$I-}
	reset(GG);
	test_error(mess);
	{$I+}
end;

procedure file_output(mess: PathStr; var GG: text);
begin
	assign(GG, mess);
	{$I-}
	rewrite(GG);
	test_error(mess);
	{$I+}
end;

procedure file_copy(file_src, file_dest: PathStr; OverWrite: Boolean);
var 
	F_dest, F_src: File;
	NumRead, NumWritten: Word;
	Buf: Array[1..2048] Of Char;
begin
	file_done := False;
	{$I-}
	test_error(file_src);
	if file_exist_check(file_dest) then
	begin
		if not OverWrite then Exit; 
		Assign(F_dest, file_dest);
		Reset(F_dest, 1);
		test_error(file_dest);
	end
	else
	begin
		Assign(F_dest, file_dest);
		Rewrite(F_dest, 1);
		test_error(file_dest);
	end;
		Assign(F_src, file_src);
		Rewrite(F_src, 1);
		test_error(file_src);
{$I+}
		repeat
			BlockRead(F_src, Buf, SizeOf(Buf), NumRead);
			BlockWrite(F_dest, Buf, NumRead, NumWritten);
		until (NumRead = 0) or (NumWritten <> NumRead);
		Close(F_dest);
		Close(F_src);
		file_done := True;
end;

procedure file_merge(file_src, file_dest: PathStr);
var 
	F_dest, F_src: File;
	NumRead, NumWritten: Word;
	Buf: Array[1..2048] Of Char;
begin
	file_done := False;
	{$I-}
	Assign(F_src, file_src);
	Reset(F_src, 1);
	test_error(file_src);
	if file_exist_check(file_dest) then
	begin
		Assign(F_dest, file_dest);
		Reset(F_dest, 1);
		Seek(F_dest, FileSize(F_dest));
	end
	else
	begin
		Assign(F_dest, file_dest);
		Rewrite(F_dest, 1);
	end;
	test_error(file_dest);
	repeat
		BlockRead(F_src, Buf, SizeOf(Buf), NumRead);
		BlockWrite(F_dest, Buf, NumRead, NumWritten);
	until (NumRead = 0) or (NumWritten <> NumRead);
	Close(F_dest);
	Close(F_src);
	file_done := True;
{$I+}
end;

procedure file_delete(file_dest: PathStr);
var
	F: File;
begin
	{$I-}
	Assign(F, file_dest);
	Erase(F);
	test_error(file_dest);
	{$I+}
	file_done := (IOResult = 0);
end;

procedure file_rename(file_src, file_dest : PathStr; OverWrite : Boolean);
var 
	F: File;
begin
	file_done := False;
	{$I-}
	if not file_exist_check(file_src) then
	begin
		writeln(' ', file_src, '  ');
		Exit;
	end;
	if file_exist_check(file_dest) then
		if not OverWrite then Exit
		else
		begin
			Assign(F, file_dest);
			Erase(F);
		end;
		Assign(F, file_src);
		Rename(F, file_dest);
		test_error(file_dest);
		file_done := True;
	Close(F);
	{$I+}
end;

function file_exist_check(Name: PathStr): Boolean;
var F: file;
begin
	Assign(F, Name);
	{$I-}
	Reset(F);
	test_error(Name);
	{$I+}
	if IOResult = 0 then
	begin
		file_exist_check := True;
		Close(F);
	end
	else 
		file_exist_check := False;
end;

function get_file_extension(S: PathStr): String;
var 
	mess: String;
begin
	mess := S;
	Delete(mess, 1, Pos('.', mess));
	if mess = S Then mess := '';
	get_file_extension := mess;
end;

function get_file_prefix(S: PathStr): String;
var 
	mess: String;
begin
	mess := S;
	Delete(mess,Pos('.', mess), Length(mess) - Pos('.',mess) + 1);
	get_file_prefix := mess;
end;

function get_file_dir(S: PathStr): String;
begin
	repeat
		Delete(S, Length(S), 1);
	until S[Length(S)] = '\';
	get_file_dir := S;
end;

begin
end.
