program  matrices;

type 
	row_index = array[1..100] of ^row_vector;
	row_vector = array[1..100] of Integer;
	matrix = record
		no_rows, no_cols: Word;
		index_ptr: ^row_index;
	end;

var 
	A, B, C: matrix;
	inds_size, elems_size, i, k: Word;
	m, n: LongInt;
procedure  create_matrix(var  A: matrix;  r, c: Word);

var 
	j, k: Word;

begin
	with  A  do
	begin
		no_rows := r;  no_cols := c;
		j := no_rows * sizeof(Pointer);
		inc(inds_size, j);
		GetMem(index_ptr, j);
		for  j := 1  to  no_rows  do
		begin
			k := no_cols * sizeof(integer);
			inc(elems_size, k);
			GetMem(index_ptr^[j], k);
			for  k := 1  to  no_cols  do
				index_ptr^[j]^[k] := -5 + random(11);
		end;
	end;
end;

procedure  delete(var  A: matrix);
var  
	j: Word;
begin
	with A do
	begin
		for  j := 1  to  no_rows  do
			FreeMem(index_ptr^[j], no_cols * sizeof(integer));
		FreeMem(index_ptr, no_rows * sizeof(Pointer));
		index_ptr := nil;
	end;
end;

procedure product_matrix(var A, B, C: matrix);
var 
	i, j, k: Word;
	sum: LongInt;
begin
	if A.no_cols <> B.no_rows  then  halt;
	create_matrix(C, A.no_rows, B.no_cols);
	for  i := 1  to  A.no_rows  do
		for  k := 1  to  B.no_cols  do
		begin
			sum := 0;
			for  j := 1  to  A.no_cols  do
				sum := sum + 
					A.index_ptr^[i]^[j] * B.index_ptr^[j]^[k];
			C.index_ptr^[i]^[k] := sum;
		end;
end;

procedure print_matrix(var A: matrix; ss: string);
var 
	i, k: Word;
begin
	with  A  do
	begin
		WriteLn(ss);
		for i := 1 to  no_rows  do
		begin
			for  k := 1  to no_cols  do
				Write(index_ptr^[i]^[k]:4);
			WriteLn;
		end;
	end;
end;

begin
	inds_size := 0;  elems_size := 0;
	m := MemAvail;
	WriteLn('। ࠧ饭 ᢮ ', m:8, ' ');
	randomize;
	create_matrix(A, 4, 5);
	create_matrix(B, 5, 3);
	product_matrix(A, B, C);
	n := MemAvail;
	WriteLn('᫥ ࠧ饭 ᢮ ', n:8, ' ');
	WriteLn('饭                 ', m-n:8, ' ');
	WriteLn('⥫                 ', inds_size:8, ' ');
	WriteLn('         ', elems_size:8, ' ');
	m := m - n - inds_size - elems_size;
	print_matrix(A, ' A = ');
	print_matrix(B, ' B = ');
	print_matrix(C, 'ந  A*B = ');
	delete(C);
	delete(B);
	delete(A);
	m := MemAvail;
	WriteLn('᫥ ᢮ ᢮ ', m:8, ' ');
	WriteLn(' <Enter>');
	ReadLn;
end.


