unit list;

interface

type 
	node_ptr = ^node;
	node = record 
		coefficient: Real;
		degree: Word;
		next: node_ptr;
	end;

var 
	root: node_ptr;

procedure create_list(n: Word);
procedure destroy_list;
procedure insert_after(var q, s: node_ptr);
procedure insert_before(var q, s: node_ptr);
procedure insert_at_end(var s: node_ptr);
procedure remove_after(q: node_ptr);
procedure remove(var q: node_ptr);

implementation 

procedure create_list(n: Word);
var 
	temp: node_ptr;
	k: Word;
begin 
	root := nil;
	for k := 0 to n - 1 do 
	begin 
		temp := root;
		New(root);
		with root^ do 
		begin 
			coefficient := 100.0*Random - 50.0;
			degree := k;
			next := temp;
		end;
	end;
end;

procedure destroy_list;
var 
	temp: node_ptr;
begin 
	while root <> nil do 
	begin 
		temp := root^.next;
		Dispose(root);
		root := temp;
	end;
end;

procedure insert_after(var q, s: node_ptr);
begin 
	s^.next := q^.next;
	q^.next := s;
end;

procedure insert_before(var q, s: node_ptr);
var 
	temp: node_ptr;
begin 
	New(temp);
	temp^ := q^;
	q^ := s^;
	q^.next := temp;
	Dispose(s);  s := nil;
end;

procedure insert_at_end(var s: node_ptr);
var 
	run: node_ptr;
begin 
	if root = nil then
		root := s
	else 
	begin 
		run := root;
		while run^.next <> nil do 
			run := run^.next;
		run^.next := s;
	end;
	s^.next := nil;
end;

procedure remove(var  q: node_ptr);
var 
	temp: node_ptr;
begin 
	temp := q^.next;
	if temp <> nil then 
	begin
		q^ := temp^;
		Dispose(temp);
	end 
	else 
		if q = root then
		begin
			root := nil;
			Dispose(q);
		end 
		else
		begin
			temp := root;
			while temp^.next <> q do temp := temp^.next;
			remove_after(temp);
		end;
	q := nil;
end;

procedure  remove_after(q: node_ptr);
var 
	temp: node_ptr;
begin 
	temp := q^.next;
	if temp <> nil then 
	begin
		q^.next := temp^.next;
		Dispose(temp);
	end;
end;

end.


