program keyborad_last_song;

uses dos, crt;

var 
	keyb_status_byte : byte absolute $40:$17;
	num, caps, scroll : boolean;
	old_num, old_caps, old_scroll : boolean;
	loop : byte;
	k : Integer;

const
	max = 51;

procedure get_leds_status(var n, c, s : boolean);

begin
	s := true;
	if (keyb_status_byte and $10) = 0 then s := false;
	n := true;
	if (keyb_status_byte and $20) = 0 then n := false;
	c := true;
	if (keyb_status_byte and $40) = 0 then c := false;
end;

procedure set_leds_status(n, c, s : boolean);
var 
	reg : registers;
begin
	if s then 
		keyb_status_byte := keyb_status_byte or $10
	else 
		keyb_status_byte := keyb_status_byte and not $10;
	if n then 
		keyb_status_byte := keyb_status_byte or $20
	else 
		keyb_status_byte := keyb_status_byte and not $20;
	if c then 
		keyb_status_byte := keyb_status_byte or $40
	else 
		keyb_status_byte := keyb_status_byte and not $40;
	reg.ax := $0200;
	intr($16,reg);
end;

procedure keyb_song(tone : integer);

const	
	melody : array[0..max, 1..2] of integer =(
		(0,     0), (1046, 200), (1046, 200), (1174, 400), (1046, 400),
		(1398, 400), (1318, 800), (1046, 200), (1046, 200), (1174, 400),
		(1046, 400), (1568, 400), (1398, 800), (1046, 200), (1046, 200),
		(2092, 400), (1760, 400), (1398, 400), (1318, 400), (1174, 800),
		(1864, 200), (1864, 200), (1760, 400), (1398, 400), (1568, 400),
		(1398, 800), (1046, 200), (1046, 200), (1174, 400), (1046, 400),
		(1398, 400), (1318, 800), (1046, 200), (1046, 200), (1174, 400),
		(1046, 400), (1568, 400), (1398, 800), (1046, 200), (1046, 200),
		(2092, 400), (1760, 400), (1398, 400), (1318, 400), (1174, 800),
		(1864, 200), (1864, 200), (1760, 400), (1398, 400), (1568, 400),
		(1398, 800), (0,     0));
begin
	sound(melody[tone][1]);
	delay(melody[tone][2]);
	nosound;
end;

begin
	get_leds_status(old_num, old_caps, old_scroll);
	num:= false;
	caps := false;
	scroll := false;
	loop := 0;
	k := 0;
	writeln(' <Enter>  ⠭ ணࠬ');
	repeat
		keyb_song(k);
		k := (k + 1) mod max;
		loop := random(4);
		case loop of
			0 : scroll := false;
			1 : num    := true;
			2 : begin
				num  := false;
				caps := true;
			end;
			3 : begin
				caps := false;
				scroll := true;
			end;
		end;
		set_leds_status(num, caps, scroll);
	until keypressed;
	set_leds_status(old_num, old_caps, old_scroll);
end.
