{$M 4096,0,0}
program execute_at_time;

uses crt, dos;

var 
	time_to_run, program_to_run, cur_time : string;
	h_str, m_str, s_str, hnd_str: string[2];
	ch : char;
	hours, minutes, seconds, hunds : Byte;

procedure current_time(var hrs, min, sec, hnd : Byte);

var 
	regs : registers;

begin
	with regs do
	begin
		ax := 44 shl 8;
		msdos(regs);
		hrs := ch;
		min := cl;
		sec := dh;
		hunds := dl;
	end;
end;

procedure cursor_off;
var 
	regs : registers;
begin
	regs.ax :=$0100;
	regs.cx :=$2607;
	intr($10, regs);
end;

procedure cursor_on;
var 
	regs : registers;
begin
	regs.ax :=$0100;
	regs.cx :=$0506;
	intr($10, regs);
end;

procedure input(var time, command : string);

var 
	loop  : integer;
	p1,p2 : string;
	found_time : boolean;

begin
	if (paramcount <> 2) then
	begin
		writeln;
		writeln(' ᯮ짮: attime :: ');
		writeln;
		cursor_on;
		halt;
	end
	else 
	begin
		found_time := false;
		p1 := paramstr(1);
		p2 := paramstr(2);
		loop := Pos(':', p1);
		if loop <> 0 then
		begin
			found_time := true;
			time := p1;
			command := p2;
		end;
		if not found_time then loop := Pos(':', p2);
		if loop = 0 then
		begin
			found_time := true;
			time := p2;
			command := p1;
		end;
		if not found_time then
		begin
			writeln;
			writeln('ᯮ짮: attime :: ');
			writeln;
			cursor_on;
			halt;
		end;
	end;
end;

function time_rest(r_time : string) : string;

var 
	hours_to_run, minutes_to_run, seconds_to_run : Byte;
	code : integer;
	str1, str2, str3 : string[2];
	tmp1, tmp2, tmp3, time_rest_to_start : LongInt;

const
	seconds_in_a_day : LongInt = 86400;

begin

	val(copy(r_time, 1, 2), hours_to_run, code);
	val(copy(r_time, 4, 2), minutes_to_run, code);
	val(copy(r_time, 7, 2), seconds_to_run, code);

	tmp3 := seconds_to_run - seconds;
	tmp2 := minutes_to_run - minutes;
	tmp1 := hours_to_run - hours;

	time_rest_to_start := tmp1 * 3600 + tmp2 * 60 + tmp3;

	if time_rest_to_start < 0 then
		time_rest_to_start := time_rest_to_start + 				
												seconds_in_a_day;
	tmp1 := time_rest_to_start div 3600;
	tmp2 := time_rest_to_start mod 3600 div 60;
	tmp3 := time_rest_to_start - tmp1 * 3600 - tmp2 * 60;

	str(tmp3, str3);
	if length(str3) = 1 then str3 := '0' + str3;

	str(tmp2, str2);
	if length(str2) = 1 then str2 := '0' + str2;

	str(tmp1, str1);
	if length(str1) = 1 then str1 := '0' + str1;

	time_rest := str1 + ':' + str2 + ':' + str3;
end;

procedure beep;
begin
	sound(500); 
	delay(1000); 
	nosound;
end;

begin
	checkbreak := false;
	cursor_off;
	input(time_to_run, program_to_run);
	clrscr;
	gotoxy(20, 10);  writeln('-------------------------------------');
	gotoxy(20, 11);  writeln('|                                   |');
	gotoxy(20, 12);  writeln('| 饥 ६       :             |');
	gotoxy(20, 13);  writeln('| ६         :             |');
	gotoxy(20, 14);  writeln('|  ᪠ ⠫ :             |');
	gotoxy(20, 15);  writeln('| ணࠬ           :             |');
	gotoxy(20, 16);  writeln('|                                   |');
	gotoxy(20, 17);  writeln('-------------------------------------');
	gotoxy(20, 18);  writeln('         |  alt-x : 室  |         ');
	gotoxy(20, 19);  writeln('         -------------------         ');
	gotoxy(44, 13);  writeln(time_to_run);
	gotoxy(44, 15);  writeln(program_to_run);

	repeat
		current_time(hours, minutes, seconds, hunds);
		str(hours, h_str);
		if hours = 0 then h_str:='00';
		str(minutes, m_str);
		str(seconds ,s_str);
		str(hunds, hnd_str);

		if length(m_str) = 1 then m_str := '0' + m_str;
		if length(s_str) = 1 then s_str := '0' + s_str;
		cur_time := h_str + ':' + m_str + ':' + 
									s_str + ':' + hnd_str;

		if keypressed then
		begin
			ch := readkey;
			if ch = #0 then
			begin
				ch := readkey;
				if ch = 'X' then
				begin
					cursor_on;
					clrscr;
					halt;
				end;
			end;
		end;
		gotoxy(44, 12);
		writeln(cur_time);
		gotoxy(44, 14);
		writeln(time_rest(time_to_run));
	until time_to_run = copy(cur_time, 1, 8);
	

	clrscr;
	exec(getenv('comspec'),'/c '+ program_to_run);
	cursor_on;
end.
