program test_text_video;

uses dos, crt;

const 
	ss: array[1..12] of string[40] =(
			'           HAPPY HALLOWEEN!!!!          ',
			'                                        ',
			'        oooooooooooooooooooooooo        ',
			'     oooooooooooooooooooooooooooooo     ',
			'  oooooooo     oooooooooo     oooooooo  ',
			' ooooooooo     oooooooooo     ooooooooo ',
			'oooooooooo     oooooooooo     oooooooooo',
			'oooooooooooooooooooooooooooooooooooooooo',
			' oooooooooooooooooooooooooooooooooooooo ',
			'   oooooooooo               ooooooooo   ',
			'      oooooooooo         ooooooooo      ',
			'               ooooooooooo              ');

var 
	x, y, n, attr,k, col, row: byte;
	reg : registers;

procedure up(x0, y0, x1, y1, n, attr: byte);
begin
	with reg do
	begin
		ah := $06;
		al := n;
		bh := attr;
		cl := x0;  ch := y0;
		dl := x1;  dh := y1;
	end;
	intr($10, reg);
end;

procedure down(x0, y0, x1, y1, n, attr: byte);
begin
	with reg do
	begin
		ah := $07;
		al := n;
		bh := attr;
		cl := x0;  ch := y0;
		dl := x1;  dh := y1;
	end;
	intr($10, reg);
end;

procedure set_cursor_position(page, x, y: byte);
begin
	with reg do
	begin
		AH := $02;
		BH := page;
		DH := y;
		DL := x;
	end;
	intr($10, reg);
end;

procedure write_chars(page, x, y: byte; ch0: char; attr: byte;
		multiplicity: word);
begin
	set_cursor_position(page, x, y);
	with reg do
	begin
		AH := $09;
		AL := ord(ch0);
		BH := page;
		BL := attr;
		CX := multiplicity;
	end;
	intr($10, reg);
end;

procedure write_string(page, x, y: byte; ss: string;
		attr: byte);
var 
	j: word;
begin
	for  j := 1  to  length(ss)  do
	begin
		write_chars(page, x, y, ss[j], attr, 1);
		inc(x);
	end;
end;

begin
	up(0, 0, 79, 24, 0, black);
	attr := yellow;
	for row := 1  to  12  do
		write_string(0, 20, row, ss[row], attr);
	for row := 1 to 12 do
		write_chars(0, 0, row, ' ', black, col);
	k :=0;
	repeat
		inc(k);
		if odd(k) then
			for row := 0 to 9 do
			begin
				delay(100);
				down(0, 0, 79, 24, 1, black);
			end
		else
			for row := 0 to 9 do
			begin
				delay(100);
				up(0, 0, 79, 24, 1, green);
			end;
		sound(200); delay(10); nosound;
	until keypressed;
end.
