program test_Graph_unit;

uses crt, dos, Graph;

var 
	x, y, xx, yy : integer;
	ch : char;
	s  : string;
	ptr : pointer;
	size : word;

procedure test_fill_styles;

procedure fill(x, y, style : integer;  color : word; ss : string);

var 
	prev_color : word;

begin
	prev_color := getcolor;
	setcolor(white);
	outtextxy(x, y - 15, ss);
	setcolor(prev_color);
	setfillstyle(style, color);
	rectangle(x, y, x + 90, y + 90);
	bar(x + 1, y + 1, x + 89, y + 89);
end;{fill}

begin
	fill( 50,  70, emptyfill,       1,  'EmptyFill');
	fill(200,  70, solidfill,       2,  'SolidFill');
	fill(350,  70, linefill,        3,  'LineFill');
	fill(500,  70, ltslashfill,     4,  'LtSlashFill');
	fill( 50, 215, slashfill,       5,  'SlashFill');
	fill(200, 215, bkslashfill,     6,  'BkSlashFill');
	fill(350, 215, ltbkslashfill,   7,  'LtBkSlashFill');
	fill(500, 215, hatchfill,       8,  'HatchFill');
	fill( 50, 345, xhatchfill,      9,  'XHatchFill');
	fill(200, 345, interleavefill, 10,  'InterleaveFill');
	fill(350, 345, widedotfill,    11,  'WideDotFill');
	fill(500, 345, closedotfill,   12,  'CloseDotFill');
end;{test_fill_styles}

procedure fill_bar(x, y, xx, yy : integer; color, raster : byte);

const 
	fil_pat :array[0..27] of fillpatterntype =(
		($ff,$ff,$ff,$ff,$ff,$ff,$ff,$ff), 
		(0,$fb,$fb,$fb,0,$df,$df,$df),
		(0,$10,$28,$44,$28,$10,0,0), 
		($22,0,$88,0,$22,0,$88,0),
		($cc,$33,$cc,$33,$cc,$33,$cc,$33), 
		($aa,$55,$aa,$55,$aa,$55,$aa,$55),
		($94,$84,$48,$30,0,$c1,$22,$14), 
		($aa,$aa,$aa,$aa,$aa,$aa,$aa,$aa),
		($ff,0,$ff,0,$ff,0,$ff,0),
		($ff,$1,$7d,$45,$5d,$41,$7f,0),
		($01,$82,$44,$28,$10,$20,$40,$80), 
		(0,$3c,$42,$42,$42,$42,$3c,0),
		(0,$7e,$7e,$7e,$7e,$7e,$7e,0), 
		($81,$42,$24,$18,$18,$24,$42,$81),
		(0,$ec,$2a,$2a,$2a,$aa,$ec,0), 
		(0,$08,$18,$3f,$3f,$18,$08,0),
		(0,0,$7e,$42,$7e,$42,$7e,$42), 
		($80,$7f,$41,$41,$41,$41,$41,$7f),
		(0,$5d,$3e,$6b,$7f,$63,$36,$5d), 
		(0,0,$04,$08,$90,$a0,$c0,$f0),
		($92,$24,$49,$92,$24,$49,$92,$24), 
		($b1,$22,$14,$14,$22,$91,$48,$24),
		($18,$3c,$3c,$7e,$7e,$3c,$3c,$18), 
		($e7,$c3,$81,$18,$18,$81,$c3,$e7),
		($2,$91,$68,$8,$10,$16,$89,$40), 
		($ff,$81,$81,$81,$81,$81,$81,$ff),
		(0,0,$81,$81,$42,$24,$18,$18), 
		($c3,$42,$5a,$7e,$7e,$5a,$42,$c3));
begin
	if raster < 28 then
	begin
		setfillpattern(fil_pat[raster], color);
		setfillstyle(12, color);
		bar(x, y, xx, yy);
	end;
end;{fill_bar}

procedure shadow_text(x, y : integer; text : string; bg, vg, font, size : byte);
begin
	settextstyle(font, 0, size);
	setcolor(bg);
	outtextxy(x, y, text);
	setcolor(vg);
	outtextxy(x + 1, y + 1, text);
	settextstyle(0, 0, 0);
end;

procedure info(s : string);
begin
	fill_bar(0, 0, 639, 49, 0, 0);
	shadow_text(20, 5, s, 14, 6, 2, 6);
end;

procedure test_get_put_image;

var 
	ptr : pointer;
	size : word;

begin
	setfillstyle(solidfill, lightcyan);
	fillellipse(100, 210, 20, 20);
	circle(140, 210, 20);
	rectangle(80, 190, 160, 230);
	size := imagesize(80, 190, 160, 230);
	getmem(ptr, size);
	getimage(80, 190, 160, 230, ptr^);
	setcolor(white);
	setfillstyle(solidfill, blue);
	bar(280, 60, 400, 440);
	putimage(300, 100, ptr^, CopyPut);
	putimage(300, 160, ptr^, orput);
	putimage(300, 220, ptr^, xorput);
	putimage(300, 280, ptr^, notput);
	putimage(300, 340, ptr^, andput);
	outtextxy(410, 120, 'CopyPut');
	outtextxy(410, 180, 'OrPut');
	outtextxy(410, 240, 'XorPut');
	outtextxy(410, 300, 'NotPut');
	outtextxy(410, 360, 'AndPut');
	freemem(ptr, size);
end;

procedure test_palette;

const 
	col_num : array[0..15] of word = 
		(0, 1, 2, 3 ,4 ,5, 20, 7, 56, 57, 58, 59, 60, 61, 62, 63);

var 
	k : word;

begin
	randomize;
	SetRGBPalette(col_num[lightred], 63, 10, 10);
	setfillstyle(solidfill, lightred);
	bar(30, 50, 179, 450);
	SetRGBPalette(col_num[lightgreen], 9, 63, 9);
	setfillstyle(solidfill, lightgreen);
	bar(180, 50, 329, 450);
	SetRGBPalette(col_num[lightblue], 0, 0, 63);
	setfillstyle(solidfill, lightblue);
	bar(330, 50, 479, 450);
	SetRGBPalette(col_num[brown], 40, 30, 0);
	setfillstyle(solidfill, brown);
	bar(480, 50, 629, 450);
	setcolor(white);
	outtextxy( 30, 50, 'LightRed');
	outtextxy(180, 50, 'LightGreen');
	outtextxy(330, 50, 'LightBlue');
	outtextxy(480, 50, 'Brown');
	delay(1000);
	repeat
		SetRGBPalette(col_num[lightred], 63, random(40), random(40));
		delay(100);
		SetRGBPalette(col_num[lightgreen], random(40), 63, random(40));
		delay(100);
		SetRGBPalette(col_num[lightblue], random(40), random(40), 63);
		delay(100);
		SetRGBPalette(col_num[brown], 30 + random(20), 20 + random(20), 0);
		delay(100);
	until keypressed;
end;

procedure horizontal_reflection(mx, my, mxx, myy : integer);

var  
	pix1, pix2 : integer;

begin
	if (mx < 0) or (my < 0) or (mxx > GetMaxX) or (myy > GetMaxY) then exit;
	for x := mx to mxx do

		for y := my to (my + myy) div 2 do

		begin
			pix1 := getpixel(x, y);
			pix2 := getpixel(x, my + myy - y);
			putpixel(x, my + myy - y, pix1);
			putpixel(x, y, pix2);
		end;
end;

procedure vertical_reflection(mx, my, mxx, myy : integer);

var 
	pix1, pix2 : integer;

begin
	if (mx < 0) or (my < 0) or (mxx > GetMaxX) or (myy > GetMaxY) then exit;
	for y := my to myy do
		for x := mx to (mx + mxx) div 2 do
		begin
			pix1 := getpixel(x, y);
			pix2 := getpixel(mx + mxx - x, y);
			putpixel(mx + mxx - x, y, pix1);
			putpixel(x, y, pix2);
		end;
end;

begin
	x := vga; y := vgahi;
	InitGraph(x, y, '');
	ClearViewPort;
	setcolor(15);
	rectangle(10, 50, 639, 450);
	info('Press <Enter>');
	ReadLn;

	info('Fill_Bar, Press <Enter>');
	fill_bar(11, 51, 638, 449, 3, 5);
	fill_bar(50, 100, 280, 180, 4, 4);
	fill_bar(450, 80, 580, 150, 0, 0);
	fill_bar(500, 350, 600, 430, 14, 20);
	ReadLn;

	info('Shadow_text, Press <Enter>');
	Shadow_text(100, 200, 'SHADOWTEXT...', 15, 7, 0, 2);
	Shadow_text(120, 230, 'HELLO!HELLO!!!', 13, 5, 0, 3);
	Shadow_text(140, 260, 'good bye, good bye...', 0, 11, 2, 6);
	ReadLn;

	info('Test_get_put_image, Press <Enter>');
	test_get_put_image;
	ReadLn;

	clearviewport;
	info('Test_fill_styles, Press <Enter>');
	rectangle(10, 50, 639, 450);
	fill_bar(11, 51, 638, 449, 3, 5);
	test_fill_styles;
	ReadLn;

	info('Test_palette, Press <Enter>');
	test_palette;
	ReadLn;

	info('FloodFill, Circle, Ellipse, Setfillstyle, Press <Enter>');
	setcolor(15);
	circle(100, 350, 50);
	setfillstyle(1, 8);
	floodfill(100, 350, 15);
	setcolor(13);
	fillellipse(150, 350, 30, 60);
	setfillstyle(2, 4);
	floodfill(150, 350, 13);
	setcolor(10);
	setfillstyle(4, 5);
	fillellipse(250, 150, 90, 60);
	ReadLn;

	info('Vertical reflection, Press <Enter>');
	vertical_reflection(0, 50, 639, 450);
	ReadLn;

	info('Horizontal reflection, Press <Enter>');
	horizontal_reflection(0, 50, 639, 450);
	ReadLn;
end.
