program buffon;

uses crt, Graph, Graphs;

var 
	crossed, thrown, drawlinecount, ltemp, rescalecount :  longint;
	half_length : double;
	nline, offset, step :  word;

procedure drawlines;
var 
	row :  word;
begin
	setlinestyle(0, 0, 1);
	setcolor(white);
	row := offset;
	nline := 0;
	while (row <= getmaxy) do 
	begin
		line(0, row, getmaxx, row);
		inc(row, step);
		inc(nline)
	end
end;

procedure setuplines;
begin
	clearviewport;
	offset := getmaxy div 10;
	step := getmaxy div 5;
	half_length := 0.5 * step;
	drawlines
end;

procedure beep;
begin
	sound(500); delay(2); nosound;
end;

procedure thrown_needle;
var 
	alpha, cos_theta, hypotenuse, sin_theta, x, y : real;
	x_delta, y_delta, x_mid, y_mid : integer;
begin
	alpha := random - 0.5;
	x := 2.0 * (random - 0.5);
	y := random;
	if x = 0.0 then
	begin
		sin_theta := 1.0;
		cos_theta := 0.0
	end
	else
	begin
		hypotenuse := sqrt(sqr(x) + sqr(y));
		sin_theta := y / hypotenuse;
		cos_theta := x / hypotenuse
	end;
	inc(thrown);
	if abs(alpha) <= 0.5 * sin_theta then
	begin
		inc(crossed); 
		beep;
	end;
	x_mid := random(getmaxx + 1);
	y_mid := offset + step * random(1 + nline) + round(alpha * step);
	x_delta := round(half_length * cos_theta);
	y_delta := round(half_length * sin_theta);
	setcolor (1 + random(getmaxcolor));
	line (x_mid - x_delta, y_mid - y_delta, x_mid + x_delta, y_mid + y_delta);
end;

procedure buffon_finished;
var 
	pi_approximate : real;
begin
	clrscr;
	writeln;
	writeln (' '' 䮭'' - ᯥਬ⠫쭮 । ᫠ ');
	writeln;
	writeln('襭         ', thrown:9);
	write('祭  ﬨ ',   crossed:9);
	writeln;
	if crossed > 0 then
	begin
		pi_approximate := 2.0 * thrown / crossed;
		writeln('ਡ 祭 ᫠  ', pi_approximate:8:6);
	end;
	writeln;
end;

begin
	randomize;
	thrown  := 0;
	crossed := 0;
	rescalecount := 2000;
	drawlinecount := rescalecount div 5;
	open_Graph;
	setviewport (0,0, getmaxx, getmaxy, clipon);
	setuplines;
	repeat
		thrown_needle; 
		delay(200)
	until keypressed;
	close_Graph;
	buffon_finished;
	WriteLn(' <Enter>');
	readln; readln;
end.
