program pixel;

uses crt, dos;

type 
	screenbuffertype = array[0..63999] of byte;
	screenbufferptr = ^screenbuffertype;

var 
	screen : screenbufferptr;
	hres, vres : word;
	color : byte;

procedure init_Graph;
var 
	regs : registers;
begin
	regs.ah := $00;
	regs.al := $13;
	intr($10, regs);
	screen := ptr($a000, 0);
end;

procedure close_Graph;
var 
	regs : registers;
begin
	regs.ah := $00;
	regs.al := $03;
	intr($10, regs);
end;

procedure set_pixel(x, y : word; color : byte);
var 
	address : word;
begin
	address := y * 320 + x;
	screen^[address] := color;
end;

begin
	hres := 320; vres := 200; color := 255;
	randomize;
	init_Graph;
	repeat
		set_pixel(random(hres), random(vres), random(color+1));
	until keypressed;
	close_Graph;
end.
