program line;

uses crt, dos;

type 
	screenbuffertype = array[0..63999] of byte;
	screenbufferptr = ^screenbuffertype;
	screentype = record
		buffer : screenbufferptr;
		ytable : array[0..199] of word;
		width  : word;
		color  : word;
	end;

var 
	screen : screentype;
	screen_y : array[0..199] of word;
	i, j : word;

procedure calcscreeny(width : word);
var 
	i : integer;
begin
	for i := 0 to 199 do
		screen_y[i] := i * width;
end;

procedure init_Graph;
var 
	regs : registers;
begin
	regs.ah := $00;
	regs.al := $13;
	intr($10, regs);
	screen.buffer := ptr($a000, 0);
	screen.width := 320;
	calcscreeny(320);
end;

procedure close_Graph;
var 
	regs : registers;
begin
	regs.ah := $00;
	regs.al := $03;
	intr($10, regs);
end;

procedure hline(x1, y, x2 : word; color : byte);
var 
	x, address : word;
begin
	address := screen_y[y];
	for x := x1 to x2 do 
		screen.buffer^[address+x] := color;
end;

procedure vline(x, y1, y2 : word; color : byte);
var 
	y, address : word;
begin
	address := screen_y[y1]+x;
	for y := y1 to y2 do
	begin
		screen.buffer^[address] := color;
		address := address + screen.width;
	end;
end;

begin
	init_Graph;
	for i := 0 to 199 do 
		hline(0, i, 319, i mod 255);
	readln;
	for i := 0 to 319 do 
		vline(i, 0, 199, i mod 255);
	readln;
	close_Graph;
end.
