program bresenline;

uses crt, dos;
type
  screenbuffertype = array[0..63999] of byte;
  screenbufferptr = ^screenbuffertype;
  screentype = record
    buffer : screenbufferptr;
    ytable : array[0..199] of word;
    width  : word;
    color  : word;
  end;

var
  screen : screentype;
  screen_y : array[0..199] of word;
  i, j : word;

procedure calcscreeny(width : word);
var i : integer;
begin
  for i := 0 to 199 do screen_y[i] := i*width;
end;


procedure init_graph;
var regs : registers;
begin
  regs.ah := $00;
  regs.al := $13;
  intr($10, regs);
  screen.buffer := ptr($a000, 0);
  screen.width := 320;
  calcscreeny(320);
end;

procedure close_graph;
var regs : registers;
begin
  regs.ah := $00;
  regs.al := $03;
  intr($10, regs);
end;

procedure set_pixel(x, y : word; color : byte);
var
  address : word;
begin
  address := (y shl 8) + (y shl 6) + x;
  screen.buffer^[address] := color;
end;


procedure bresenhamline(x1, y1, x2, y2 : word; color : byte);

var 
	deltax, deltay, inc1, inc2, d, x, y : integer;

begin
	deltax := x2 - x1; 
	deltay := y2 - y1;
	d := 2 * deltay - deltax;
	inc1 := deltay shl 1;
	inc2 := (deltay - deltax) shl 1;
	x := x1; y := y1;
	set_pixel(x, y, color);
	while x < x2 do
	begin
		if d < x1 then
		begin
			d := d + inc1;
			inc(x);
		end
		else
		begin
			d := d + inc2;
			inc(x);
			inc(y);
		end;
		set_pixel(x, y, color);
	end;
end;

begin
	init_Graph;
	bresenhamline(0, 0, 319, 199, 15);
	readln;
	close_Graph;
end.
