program segment_demo;
   uses  crt, dos;

type
  screenbuffertype = array[0..63999] of byte;
  screenbufferptr = ^screenbuffertype;
  screentype = record
    buffer : screenbufferptr;
    ytable : array[0..199] of word;
    width  : word;
    color  : word;
  end;

var
  screen : screentype;
  screen_y : array[0..199] of word;
  i, j : word;

procedure calcscreeny(width : word);
var i : integer;
begin
  for i := 0 to 199 do screen_y[i] := i*width;
end;

procedure init_graph;
var regs : registers;
begin
  regs.ah := $00;
  regs.al := $13;
  intr($10, regs);
  screen.buffer := ptr($a000, 0);
  screen.width := 320;
  calcscreeny(320);
end;

procedure close_graph;
var regs : registers;
begin
  regs.ah := $00;
  regs.al := $03;
  intr($10, regs);
end;

procedure hline(x1, y, x2 : word; color : byte);
var x, address : word;
begin
  address := screen_y[y];
  for x := x1 to x2 do screen.buffer^[address+x] := color;
end;

procedure vline(x, y1, y2 : word; color : byte);
var  y, address : word;
begin
  address := screen_y[y1] + x;
  for y := y1 to y2 do
  begin
    screen.buffer^[address] := color;
    address := address + screen.width;
  end;
end;

procedure set_pixel(x, y : word; color : byte);
var
  address : word;
begin
  address := (y shl 8) + (y shl 6) + x;
  screen.buffer^[address] := color;
end;

procedure segment(x0, y0, x1, y1 : integer);

var 
	dx, two_dx, dy, two_dy, abs_slope,
	Error, dError, eps, sum, t : integer;

procedure bresenham_big_y;
begin
	if  x1 < x0  then
	begin
		t := x0;  
		x0 := x1;  
		x1 := t;
		t := y0;  
		y0 := y1;  
		y1 := t;
	end;
	if  y0 < y1  then  
		eps := 1  
	else  
		eps := -1;
	Error := -dy;
	while  abs(y1 - y0) >= 2  do
	begin
		set_pixel(x0, y0, white);
		set_pixel(x1, y1, white);
		Error := Error + two_dx;
		if  Error >= 0  then
		begin
			Error := Error - two_dy;
			inc(x0);  dec(x1);
		end;
		y0 := y0 + eps;  
		y1 := y1 - eps;
	end;
	if  y0 = y1  then  
		set_pixel(x0, y0, white)
	else
	begin
		set_pixel(x0, y0, white);
		set_pixel(x1, y1, white);
	end;
end;{bresenham_big_y}

procedure bresenham_big_x;
begin
	if  y1 < y0  then
	begin
		t := x0;  
		x0 := x1;  
		x1 := t;
		t := y0;  
		y0 := y1;  
		y1 := t;
	end;
	if  x0 < x1  then  
		eps := 1  
	else  
		eps := -1;
	Error := -dx;
	while  abs(x1 - x0) >= 2  do
	begin
		set_pixel(x0, y0, white);
		set_pixel(x1, y1, white);
		Error := Error + two_dy;
		if  Error >= 0  then
		begin
			Error := Error - two_dx;
			inc(y0);  dec(y1);
		end;
		x0 := x0 + eps;  
		x1 := x1 - eps;
	end;
	if  x0 = x1  then  
		set_pixel(x0, y0, white)
	else
	begin
		set_pixel(x0, y0, white);
		set_pixel(x1, y1, white);
	end;
end;{bresenham_big_x}

begin
	if  x0 = x1  then  
		vline(x0, y0, y1, white)	
	else  
		if  y0 = y1  then  
			hline(x0, x1, y0, white)
		else
		begin
			dx := abs(x1 - x0);
			dy := abs(y1 - y0);
			two_dx := 2 * dx;  
			two_dy := 2 * dy;
					if  dx <= dy  then  
						bresenham_big_y
					else  
						bresenham_big_x;
		end;
end;{segment}

begin
	init_Graph;
	segment(10, 180, 300, 30);
	readln;
	close_Graph;
end.
