Program circle_demo;

   uses  crt, dos;

   const  no_rows = 200;
          no_cols = 320;
            x_max = no_cols div 2;
            x_min = - x_max + 1;
            y_max = no_rows div 2;
            y_min = - y_max + 1;

type
  screenbuffertype = array[0..63999] of byte;
  screenbufferptr = ^screenbuffertype;
  screentype = record
    buffer : screenbufferptr;
    ytable : array[0..199] of word;
    width  : word;
    color  : word;
  end;

var
  screen : screentype;
  screen_y : array[0..199] of word;
  i, j : word;

procedure calcscreeny(width : word);
var i : integer;
begin
  for i := 0 to 199 do screen_y[i] := i*width;
end;

procedure init_graph;
var regs : registers;
begin
  regs.ah := $00;
  regs.al := $13;
  intr($10, regs);
  screen.buffer := ptr($a000, 0);
  screen.width := 320;
  calcscreeny(320);
end;

procedure close_graph;
var regs : registers;
begin
  regs.ah := $00;
  regs.al := $03;
  intr($10, regs);
end;


procedure set_pixel(x, y : word; color : byte);
var
  address : word;
begin
  address := (y shl 8) + (y shl 6) + x;
  screen.buffer^[address] := color;
end;

   procedure  circle(x0, y0, r: integer);

      var  x, y, s: integer;
            xx, yy: array[1..8] of integer;
                 k: word;

      begin
      if  (x0 + r > x_max) or (x0 - r < x_min) or
          (y0 + r > y_max) or (y0 - r < y_min)  then  exit;
      set_pixel(x0 + r, y0, white);
      set_pixel(x0 - r, y0, white);
      set_pixel(x0, y0 + r, white);
      set_pixel(x0, y0 - r, white);
      x := r;  y := 0;  s := 3 - 2*r;
      for  k := 1  to  4  do
         begin
         yy[k] := y0;  xx[4 + k] := x0;
         end;
      xx[1] := x0 + r;  xx[2] := xx[1];
      xx[3] := x0 - r;  xx[4] := xx[3];
      yy[5] := y0 + r;  yy[6] := y0 - r;
      yy[7] := yy[5];   yy[8] := yy[6];
      while  y < x - 1  do
         begin
         inc(yy[1]);  yy[3] := yy[1];
         dec(yy[2]);  yy[4] := yy[2];
         inc(xx[5]);  xx[6] := xx[5];
         dec(xx[7]);  xx[8] := xx[7];
         if  s <= 0  then  s := s + 4*y + 6
         else
            begin
            s := s + 4*(y - x) + 10;  dec(x);
            dec(xx[1]);  xx[2] := xx[1];
            inc(xx[3]);  xx[4] := xx[3];
            dec(yy[5]);  yy[7] := yy[5];
            inc(yy[6]);  yy[8] := yy[6];
            end;
         inc(y);
         if  x = y  then
            for  k := 1  to  4  do  set_pixel(xx[k], yy[k], white)
         else  for  k := 1  to  8  do  set_pixel(xx[k], yy[k], white);
         end;
      end;

   begin
   init_graph;
   circle(140, 60, 20);
   readln;
   close_graph;
   end.