program demo_VGA;

uses crt, graph, dos;

var 
	GraphDriver, GraphMode: integer;
	k: word;
	x, y, attr, x1, y1, top, bottom, mode, cols, page: byte;
	ss, tt: string[80];
	reg: registers;

procedure set_cursor_position(page, x, y: byte);
begin
	with reg do
	begin
		AH := $02;
		BH := page;
		DH := y;
		DL := x;
	end;
	intr($10, reg);
end;

procedure  get_cursor(page: byte; var  x, y : byte);
begin
	reg.AH := $03;
	reg.BH := page;
	intr($10, reg);
	with  reg  do
	begin
		y := DH;
		x := DL;
	end;
end;

procedure write_chars(page, x, y: byte; ch0: char;  attr: byte; multiplicity: word);
begin
	set_cursor_position(page, x, y);
	with reg do
	begin
		AH := $09;
		AL := ord(ch0);
		BH := page;
		BL := attr;
		CX := multiplicity;
	end;
	intr($10, reg);
end;

procedure write_string(page, x, y: byte; ss: string; attr: byte);
var 
	j: word;
begin
	for j := 1 to length(ss) do
	begin
		write_chars(page, x, y, ss[j], attr, 1); 
		inc(x);
	end;
end;

begin
	GraphDriver := detect;
	InitGraph(GraphDriver, GraphMode, '');
	setbkcolor(darkgray);
	setcolor(lightblue);
	ss := 'Graphics mode';
	fillellipse(320, 240, 20, 20);
	x := 0;  
	y := 0;
	write_string(0, x, y, ss, white);
	set_cursor_position(0, 0, 5);
	y := 5;
	attr := 16 * brown + lightcyan;
	for  k := 0  to  15  do
	begin
		str(k:3, ss);
		x := 3 * k;
		write_string(0, x, y, ss, attr);
	end;
	for k := 0 to 15 do
		write_chars(0, 3 * k + 2, 6, chr(k), attr, 1);
	set_cursor_position(0, 0, 8);
	y := 8;
	for  k := 0  to  15  do
	begin
		str((16 + k):3, ss);
		x := 3 * k;
		write_string(0, x, y, ss, attr);
	end;
	for k := 0 to 15 do
		write_chars(0, 3 * k + 2, 9, chr(16 + k), attr, 1);
	ss := '0123456';
	x := 0;  
	y := 20;
	write_string(0, x, y, ss, 11);
	get_cursor(0, x, y);
	str(x, ss);  
	str(y, tt);
	inc(y);
	ss := 'At end of "0123456", (x, y) = (' + ss + ', ' + tt + ')';
	write_string(0, x, y, ss, white);
	ss := 'Press <Enter>: ';
	x := 0;  
	y := 25;
	attr := 16 * darkgray + yellow;
	write_string(0, x, y, ss, attr);
	get_cursor(0, x, y);
	repeat
		write_chars(0, x, y, '', yellow, 1); 
		delay(100);
		write_chars(0, x, y, '', lightblue, 1); 
		delay(100);
	until  keypressed;
	readln;
	CloseGraph;
end.
