program test_graph_pages;

uses Crt, Dos, Graph;

var 
	GraphDriver, GraphMode, k: integer;
	ss, tt: string;
	reg: registers;

  procedure  set_cursor_position(page, x, y: byte);

      begin
      with  reg  do
         begin
         AH := $02;
         BH := page;
         DH := y;
         DL := x;
         end;
      intr($10, reg);
      end;

   procedure  write_chars(page, x, y: byte;
                          ch0: char;  attr: byte;
                          multiplicity: word);
      begin
      set_cursor_position(page, x, y);
      with  reg  do
         begin
         AH := $09;
         AL := ord(ch0);
         BH := page;
         BL := attr;
         CX := multiplicity;
         end;
      intr($10, reg);
      end;


   procedure  write_string(page, x, y: byte; ss: string; attr: byte);

      var  j: word;

      begin
      for  j := 1  to  length(ss)  do
         begin
         write_chars(page, x, y, ss[j], attr, 1);
         inc(x);
         end;
      end;

begin
	GraphDriver := VGA;
	graphmode := VGAMed;
	InitGraph(GraphDriver, GraphMode, '');
	write_string(0, 20, 0, 'Page 0', Yellow);
	write_string(0, 20, 1, 'Press <Enter>: ', Yellow);
	write_string(1, 30, 0, 'Page 1', Magenta);
	write_string(1, 30, 1, 'Press <Enter>: ', Magenta);
	setvisualpage(0);
	setactivepage(1);
	ss := 'XX';
	for  k := 0  to  25  do
	begin
		str(k, tt);
		tt := tt + '  ' + ss;
		if k <= 9 then 
			tt := ' ' + tt;
		write_string(1, 0, k, tt, LightGreen);
		line(0, 13 + 14 * k, 8 * length(tt), 13 + 14 * k);
		ss := ss + 'XX';
	end;
	setcolor(white);
	setfillstyle(ltbkslashfill, LightRed);
	bar(500, 0, 600, 349);
	readln;
	setvisualpage(1);
	setactivepage(0);
	setcolor(LightMagenta);
	setfillstyle(xhatchfill, LightCyan);
	fillellipse(500, 175, 137, 100);
	readln;
	setvisualpage(0);
	readln;
	setvisualpage(1);
	readln;
	RestoreCRTMode;
end.
