program save_VGA;

uses dos, crt, graph;

const 
	pixels = 38400;
	file_name = 'picture';

type 
	plane = array[1..pixels] of byte;

var 
	storage: file;
	result: word;
	graph_driver, graph_mode: integer;

procedure fill_screen;
const  
	dx = 640 div 4;  
	dy = 480 div 4;
var 
	i, j, x, y: integer;
	color: word;
begin
	color := 0;  y := 0;
	for i := 0 to 3 do
	begin
		x := 0;
		for  j := 0  to  3  do
		begin
			setfillstyle(solidfill, color);
			bar(x, y, x + dx, y + dy);
			inc(x, dx);  inc(color);
		end;
		inc(y, dy);
	end;
end;

procedure copy_screen;
var 
	i: byte;
begin
	assign(storage, file_name);
	rewrite(storage, 1);
	port[$3CE] := 4;
	for i := 3 downto 0 do
	begin
		port[$3CF] := i;
		BlockWrite(storage, mem[segA000:$0000], pixels, result);
		if result <> pixels  then
		begin
			writeln(' : i = ', i);
			readln;  
			halt;
		end;
	end;
	close(storage);
end;

procedure restore_screen;
var 
	i, j, k: byte;
begin
	assign(storage, file_name);
	reset(storage, 1);
	port[$3C4] := 2;
	j := 8;
	repeat
		port[$3C5] := j;
		blockread(storage, mem[segA000:$0000], pixels, result);
		if result <> pixels then break;
		j := j shr 1;
	until j = 0;
	close(storage);
	port[$3C5] := $0F;
end;

begin
	clrscr;
	graph_driver := detect;
	initgraph(graph_driver, graph_mode, '');
	if graphresult <> 0 then halt;
	fill_screen;
	copy_screen;
	readln;
	closegraph;
	writeln('  ,  <Enter>:');
	readln;
	initgraph(graph_driver, graph_mode, '');
	restore_screen;
	outtext('Graph screen');
	readln;
	closegraph;
end.
