program projections;

uses graph, crt, graphs3d;

var 
	x, z, y, xstep, ystep, theta : real;
	i, j, xold, yold, xnew, ynew : integer;
	P : projection;

const 
	xCount = 50;
	yCount = 50;
	xMin = -100;
	xMax =  100;
	yMin = -100;
	yMax =  100;

function Fun(x, y : real) : real;
begin
	Fun:=cos(sqrt(x * x + y * y));
end;

procedure init;
begin
	clearviewport;
	SetColor(14); setbkcolor(1);
end;

procedure FindScreenCoordinates(var x, y :real; var xp, yp : integer);
begin
	z:=10 * Fun(0.1 * x,0.1 * y);
	project(P, x, y, z, 0, 0, xnew, ynew);
end;

procedure draw_cube;
var 
	xp, yp : array[1..8] of integer;
begin
	project(P,  50,  50,  50, 0, 0, xp[1], yp[1]);
	project(P, -50,  50,  50, 0, 0, xp[2], yp[2]);
	project(P, -50, -50,  50, 0, 0, xp[3], yp[3]);
	project(P,  50, -50,  50, 0, 0, xp[4], yp[4]);
	project(P,  50,  50, -50, 0, 0, xp[5], yp[5]);
	project(P, -50,  50, -50, 0, 0, xp[6], yp[6]);
	project(P, -50, -50, -50, 0, 0, xp[7], yp[7]);
	project(P,  50, -50, -50, 0, 0, xp[8], yp[8]);	

	norm_line(xp[2], yp[2], xp[1], yp[1], White);
	norm_line(xp[3], yp[3], xp[2], yp[2], White);
	norm_line(xp[4], yp[4], xp[3], yp[3], White);
	norm_line(xp[1], yp[1], xp[4], yp[4], White);
	norm_line(xp[5], yp[5], xp[1], yp[1], White);
	norm_line(xp[6], yp[6], xp[5], yp[5], White);
	norm_line(xp[7], yp[7], xp[6], yp[6], LightGray);
	norm_line(xp[8], yp[8], xp[7], yp[7], LightGray);
	norm_line(xp[5], yp[5], xp[8], yp[8], White);
	norm_line(xp[2], yp[2], xp[6], yp[6], White);
	norm_line(xp[7], yp[7], xp[3], yp[3], LightGray);
	norm_line(xp[4], yp[4], xp[8], yp[8], White);
end;

procedure draw_surf;
begin
	xStep := (xMax - xMin) / xCount;
	yStep := (yMax - yMin) / yCount;
	for i := 0 to xcount do 
	begin
		x := xmin + i * xstep;
		y := ymin;
		findscreencoordinates(x, y, xnew, ynew);
		xold := xnew;
		yold := ynew;
		for j := 0 to ycount do 
		begin
			y:=ymin +j * ystep;
			findscreencoordinates(x, y, xnew, ynew);
			norm_line(xnew, ynew, xold, yold, Yellow);
			xold := xnew;
			yold := ynew;
		end;
	end;
	for i := 0 to ycount do 
	begin
		y := ymin + i * ystep;
		x := xmin;
		findscreencoordinates(x, y, xnew, ynew);
		xold := xnew;
		yold := ynew;
		for j := 0 to xcount do
		begin
			x := xmin + j * xstep;
			findscreencoordinates(x, y, xnew, ynew);
			norm_line(xnew, ynew, xold, yold, Yellow);
			xold := xnew;
			yold := ynew;
		end;
	end;
end;

begin
	abs_x_center := 0; abs_y_center := 0;
	open_graph;
	
	compute_isometric_matrix(P); init;
	out_text_XY('Isometric Projection', -150, 150, Yellow);
	draw_cube; readln;

	theta:=45;
	compute_oblique_matrix(theta, P); init;
	out_text_XY('Oblique Projection', -150, 150, Yellow);
	draw_cube; readln;

	theta:=15;
	compute_dimetric_matrix(theta, P); init;
	out_text_XY('Dimetric Projection', -150, 150, Yellow);
	draw_cube; readln;

	compute_isometric_matrix(P); init;
	out_text_XY('Isometric Projection', -150, 150, Yellow);
	draw_surf; readln;

	theta:=45;
	compute_oblique_matrix(theta, P); init;
	out_text_XY('Oblique Projection', -150, 150, Yellow);
	draw_surf; readln;

	theta:=15;
	compute_dimetric_matrix(theta, P); init;
	out_text_XY('Dimetric Projection', -150, 150, Yellow);
	draw_surf; readln;

	close_graph;
end.
