program cubes;

uses crt, graph, graphs;

type
	point_position = record
							x, y, z : real;
						end;
	plane_position = array[1..5] of point_position;
	cube_coordinates = array[1..6] of plane_position;

var 
	c : char;
	pcos, ncos, psin, nsin : real;

const
	cube : cube_coordinates = 	((( x : -25; y : -25; z : +25),
									 (x : +25; y : -25; z : +25),
									 (x : +25; y : +25; z : +25),
									(x : -25; y : +25; z : +25),
									(x :   0; y :   0; z : +25)),

									((x : -25; y : -25; z : -25),
									(x : +25; y : -25; z : -25),
									(x : +25; y : -25; z : +25),
									(x : -25; y : -25; z : +25),
									(x :   0; y : -25; z :   0)),

									((x : -25; y : +25; z : +25),
									(x : +25; y : +25; z : +25),
									(x : +25; y : +25; z : -25),
									(x : -25; y : +25; z : -25),
									(x :   0; y : +25; z :   0)),

									((x : -25; y : -25; z : -25),
									(x : -25; y : -25; z : +25),
									(x : -25; y : +25; z : +25),
									(x : -25; y : +25; z : -25),
									(x : -25; y :   0; z :   0)),

									((x : +25; y : -25; z : +25),
									(x : +25; y : -25; z : -25),
									(x : +25; y : +25; z : -25),
									(x : +25; y : +25; z : +25),
									(x : +25; y :   0; z :   0)),

									((x : -25; y : +25; z : -25),
									(x : +25; y : +25; z : -25),
									(x : +25; y : -25; z : -25),
									(x : -25; y : -25; z : -25),
									(x :   0; y :   0; z : -25)));

procedure rotx;
var 
	y1, z1 : real;
	i, j : integer;
begin
	for i := 1 to 6 do
		for j := 1 to 5 do
		begin
			y1 := pcos * cube[i, j].y - psin * cube[i, j].z;
			z1 := psin * cube[i, j].y + pcos * cube[i, j].z;
			cube[i, j].y := y1;
			cube[i, j].z := z1;
		end
end;

procedure roty;

var 
	x1, z1 : real;
	i, j : integer;

begin
	for i := 1 to 6 do
		for j := 1 to 5 do
		begin
			x1 := pcos * cube[i, j].x - psin * cube[i, j].z;
			z1 := psin * cube[i, j].x + pcos * cube[i, j].z;
			cube[i, j].x := x1;
			cube[i, j].z := z1;
		end
end;

procedure rotz;

var
	y1, x1 : real;
	i, j : integer;

begin
	for i := 1 to 6 do
		for j := 1 to 5 do
		begin
			y1 := pcos * cube[i, j].y - psin * cube[i, j].x;
			x1 := psin * cube[i, j].y + pcos * cube[i, j].x;
			cube[i, j].y := y1;
			cube[i, j].x := x1;
		end
end;

procedure display_cube(col : byte);

var
	i, j, a : integer;
	c : byte;
	vertex:array[1..4] of pointtype;

begin
	for i := 1 to 6 do
		if cube[i, 5].z > 0 then
		begin
			for a := 1 to 3 do
			begin
				if col > 0 then 
					c := white 
				else 
					c := 0;
				setcolor(c);
				for j := 1 to 4 do
				begin
					vertex[j].x := a * 150 + round(cube[i ,j].x);
					vertex[j].y := getmaxy div 2 + round(cube[i, j].y);
				end;
				line(vertex[1].x, vertex[1].y, vertex[2].x, vertex[2].y);
				line(vertex[2].x, vertex[2].y, vertex[3].x, vertex[3].y);
				line(vertex[3].x, vertex[3].y, vertex[4].x, vertex[4].y);
				line(vertex[4].x, vertex[4].y, vertex[1].x, vertex[1].y);
		end;
	end;
end;

procedure init;
begin
	pcos := cos(6 * 2 * pi / 360);
	ncos := cos(-6 * 2 * pi / 360);
	psin := sin(6 * 2 * pi / 360);
	nsin := sin(-6 * 2 * pi / 360);
end;

begin
	open_graph; init;
	repeat
		display_cube(1);
		repeat
			c := readkey;
			until(upcase(c) in ['X', 'Y', 'Z', 'J', 'K', 'L', 'U', 'I']) 
				or (c = #27);
			display_cube(0);
			case upcase(c) of
				'Z': rotz;
				'X': rotx;
				'Y': roty;
				'J': begin 
					rotx; 
					roty; 
				end;
				'L': begin 
					rotx; 
					rotz; 
				end;
				'K': begin 
					roty; 
					rotz; 
				end;
				'I': begin 
					rotx; 
					roty; 
					rotz; 
				end;
			end;
	until c = #27;
	repeat
		display_cube(1); 
		delay(100); 
		display_cube(0);
		rotx; 
		roty; 
		rotz;
	until keypressed;
	close_graph;
end.
