program rotating_sphere;

uses crt, graph, graphs;

type 
	Point3D = record
		X, Y, Z: Real;
	end;
	Base2D = record
		U, V: Integer;
	end;

var 
	data: array[0..25, 0..40] of Point3D;
	m, t1, t2 : integer;
	ch : char;
	Base : Base2D;
	E : Real;
	Perspective : Boolean;

const 
	rad = Pi / 180;


procedure spher_to_cartesian(radius, A, B : Integer; var P : Point3D);
var
	S1, C1, S2, C2, s3, c3 : Real;
begin
	S1 := Sin(A * Rad); C1 := Cos(A * Rad);
	S2 := Sin(B * Rad); C2 := Cos(B * Rad);
	P.X := radius * C1 * C2;
	P.Y := radius * C1 * S2;
	P.Z := radius * S1
end;


procedure Rotate(AngleX, AngleY, AngleZ : Integer; var P : Point3D);
var
	S1, S2, S3, C1, C2, C3 : Real;
	Puit : Point3D;
begin
	S1 := Sin(AngleX * Rad);
	C1 := Cos(AngleX * Rad);
	S2 := Sin(AngleY * Rad);
	C2 := Cos(AngleY * Rad);
	S3 := Sin(AngleZ * Rad);
	C3 := Cos(AngleZ * Rad);
	PUit.X := P.X * (C2 * C3) + P.Y * (C2 * S3) - P.Z * S2;
	PUit.Y := P.X * (S1 * S2 * C3 - C1 * S3) + P.Y * (S1 * S2 * S3 +
		C1 * C3) + P.Z * (S1 * C2);
	PUit.Z := P.X * (C1 * S2 * C3 + S1 * S3) + P.Y * (C1 * S2 * S3 -
		S1 * C3) + P.Z * (C1 * C2);
	P := PUIt
end;


procedure initialize(radius, Hor, Ver : Integer; Hx, Hy, Hz : Integer);
var 
	P1, P2 : Point3d;
	A, B, hor_step, ver_step : Real;
	i, j : byte;
begin
	for i := 0 to 25 do
	begin
		for j := 0 to 40 do
		begin
			Data[i, j].x := 0.0;
			Data[i, j].y := 0.0;
			Data[i, j].z := 0.0
		end
	end;
	t1 := 0;
	hor_step := 180 / Hor;
	ver_step := 360 / Ver;
	for i := 0 to Hor do
	begin
		B := 0;
		A := -90 + i * hor_step;
		spher_to_cartesian(radius, trunc(A), trunc(B), P1);
		Rotate(Hx, Hy, Hz, P1);
		t2 := 0;
		inc(t1);
		Data[t1, t2] := P1;
		for j := 0 to Ver do
		begin
			inc(t2);
			B := j * ver_step;
			spher_to_cartesian(radius, trunc(A), trunc(B), P2);
			Rotate(Hx, Hy, Hz, P2);
			Data[t1, t2] := P2;
		end;
	end;
end;


procedure Rotation(x, y, z : real);
var
	S1, S2, S3, C1, C2, C3 : Real;
	P, Puit : Point3D;
	u, v : Byte;
begin
	S1 := Sin(X * Rad);
	C1 := Cos(X * Rad);
	S2 := Sin(Y * Rad);
	C2 := Cos(Y * Rad);
	S3 := Sin(Z * Rad);
	C3 := Cos(Z * Rad);
	for u := 0 to t1 do
		for v := 0 to t2 do
		begin
			P := Data[u, v];
			PUit.X := P.X * (C2 * C3) + P.Y * (C2 * S3) - P.Z * S2;
			PUit.Y := P.X * (S1 * S2 * C3 - C1 * S3) + P.Y * (S1 * S2 * S3 +
				C1 * C3) + P.Z * (S1 * C2);
			PUit.Z := P.X * (C1 * S2 * C3 + S1 * S3) + P.Y * (C1 * S2 * S3 -
				S1 * C3) + P.Z * (C1 * C2);
			Data[u, v] := PUIt
		end;
end;

procedure TransForm(Pt3D : Point3D; var X2D, Y2D : Integer);
var
	Thit : real;
begin
	if Perspective then
	begin
		THit := 1 / (1 - Pt3D.X / E);
		X2D := trunc(Base.U + Pt3D.Y * THit);
		Y2D := trunc(Base.V - Pt3d.Z * THit)
	end
	else
	begin
		X2D := Base.U + Round(Pt3D.Y);
		Y2D := Base.V - Round(Pt3D.Z)
	end
end;

procedure LineC( x1, y1, x2, y2 : integer; color : byte);
begin
	SetColor(color); Line(x1, y1, x2, y2)
end;


procedure Line3(Point1, Point2 : Point3D; color : Integer);
var
	X1, Y1, X2, Y2 : Integer;
begin
	Transform(Point1, X1, Y1);
	Transform(Point2, X2, Y2);
	LineC(X1, Y1, X2, Y2, Color)
end;


procedure draw(Color : byte);
var 
	u, v: Byte;
begin
	for u := 1 to t2 - 1 do
		for v := 1 to t1 - 1 do
		begin
			Line3(Data[v, u], Data[v + 1, u], Color);
			Line3(Data[v, u], Data[v, u + 1], Color)
		end;
end;

begin
	open_graph; 
	setgraphmode(vgamed);  
	setbkcolor(blue);
	base.u := 320;  
	base.v := 175;
	perspective := false; 
	e := 150;
	m := 1;
	initialize(120, 10, 10, 30, -75, 14);
	ch := #32;
	repeat
		m := 1 - m;
		setactivepage(m);
		cleardevice;
		rotation(-0.0, 0.0, 0.50);
		draw(14);
		setvisualpage(m);
		if keypressed then 
			ch := readkey;
	until ch = #27;
	close_graph;
End.
