program sprite;

uses
	crt, graph, graphs;

type
	bytearraytype = array[0..65534] of byte;
	bytearrayptr = ^bytearraytype;
	spritetype = record
		height, width : integer;
		data          : bytearrayptr;
	end;

var 
	backgroundsprite, testsprite : spritetype;
	xd, yd, ox, oy, i, x, y    : integer;

procedure KillSprite(var Sprite : SpriteType);
begin
	with Sprite do
	begin
		FreeMem(Data, Width * Height);
		Width := 0; 
		Height := 0; 
		Data := nil;
	end;
end;


procedure CreateSprite(var Sprite : SpriteType; Width, Height : integer);
begin
	if Sprite.Data <> nil then 
		KillSprite(Sprite);
	Sprite.Width := Width;
	Sprite.Height := Height;
	getmem(Sprite.Data, Width * Height);
end;


procedure getsprite(var sprite : spritetype; x1, y1, x2, y2 : integer);
var 
	index, x, y : integer;
begin
	createsprite(sprite, x2-x1+1, y2-y1+1);
	index := 0;
	for y := y1 to y2 do
		for x := x1 to x2 do
		begin
			sprite.data^[index] := getpixel(x, y);
			inc(index);
		end;
end;

procedure drawsprite(var sprite : spritetype; x, y : integer);
var 
	index, xi, yi : integer;
begin
	index := 0;
	for yi := 0 to sprite.height - 1 do
		for xi := 0 to sprite.width - 1 do
		begin
			putpixel(xi + x, yi + y, sprite.data^[index]);
			inc(index);
		end;
end;


begin
	open_graph; 
	setgraphmode(ega64lo);
	line(10, 1, 10, 20); 
	line(1, 10, 20, 10);
	line(1, 1, 20, 20);  
	line(20, 1, 1, 20);
	getsprite(testsprite, 0, 0, 21, 21);
	x := 0; 
	y := 0;
	xd := 1; 
	yd := 1;
	while not keypressed do
	begin
		drawsprite(testsprite, x, y);
		inc(x, xd); 
		inc(y, yd);
		if (x = getmaxx - 20) or (x = -20) then 
			xd := -xd;
		if (y = getmaxy - 20) or (y = -20) then 
			yd := -yd;
	end;
	readln;

	clearviewport;
	setcolor(green);
	for i := 0 to 100 do
		line(random(getmaxx), random(getmaxy), random(getmaxx), random(getmaxy));
	x := 0; 
	y := 0;
	xd := 1; 
	yd := 1;
	while not keypressed do
	begin
		drawsprite(testsprite, x, y);
		inc(x, xd); 
		inc(y, yd);
		if (x = getmaxx - 20) or (x = -20) then 
			xd := -xd;
		if (y = getmaxy - 20) or (y = -20) then 
			yd := -yd;
	end;
	readln;

	clearviewport;
	setcolor(green);
	for i := 0 to 100 do
	line(random(getmaxx), random(getmaxy), random(getmaxx), random(getmaxy));
	x  := 0; 
	y  := 0;
	xd := 1; 
	yd := 1;
	while not keypressed do
	begin
		getsprite(backgroundsprite, x, y, x + 22, y + 22);
		drawsprite(testsprite, x, y);
		ox := x; 
		oy := y;
		inc(x, xd); 
		inc(y, yd);
		if (x = getmaxx - 20) or (x = -20) then 
			xd := -xd;
		if (y = getmaxy - 20) or (y = -20) then 
			yd := -yd;
		drawsprite(backgroundsprite, ox, oy);
	end;
	drawsprite(testsprite, x, y);
	readln;
	close_graph;
end.
