{$r+}
program obj_demo;

uses crt, matrices;

procedure test_real;
var 
	A0, n0, C0 : real_matrix;
	A, B, C : real_matrix_obj;
	i, j : word;
begin
	for i := 1 to max do
		for j := 1 to max do
		begin
			A0[i, j] := i * j;
			n0[i, j] := i + j;
			C0[i, j] := 0.0;
		end;
	A.init(A0);
	B.init(n0);
	C.init(C0);
	A.print('A');
	B.print('B');
	C.matrix_sum(A.M, B.M);
	C.print('A + B');
	C.matrix_product(A.M, B.M);
	C.print('A * B');
	A.done;
	B.done;
	C.done;
end;

procedure test_rational;
var 
	A0, B0, C0 : rational_matrix;
	A, B, C : rational_matrix_obj;
	i, j : word;
begin
	for  i := 1  to  max  do
		for  j := 1  to  max  do
		begin
			A0[i, j].num := i + j - 1;
			A0[i, j].den := 1;
			B0[i, j].num := 1;
			B0[i, j].den := i + j - 1;
			C0[i, j].num := 1;
			C0[i, j].den := 1;
		end;
	A.init(A0);
	B.init(B0);
	C.init(C0);
	A.print('A');
	B.print('B');
	C.matrix_sum(A.M, B.M);
	C.print('A + B');
	C.matrix_product(A.M, B.M);
	C.print('A * B');
	A.done;
	B.done;
	C.done;
end;	

procedure test_complex;
var 
	A0, B0, C0 : complex_matrix;
	A, B, C : complex_matrix_obj;
	i, j : word;
begin
	for i := 1 to max do
		for j := 1 to max do
		begin
			A0[i, j].re := 1.0;  A0[i, j].im := 0.0;
			B0[i, j].re := i;    B0[i, j].im := j;
			C0[i, j].re := 0.0;  C0[i, j].im := 0.0;
		end;
	A.init(A0);
	B.init(B0);
	C.init(C0);
	A.print('A');
	B.print('B');
	C.matrix_sum(A.M, B.M);
	C.print('A + B');
	C.matrix_product(A.M, B.M);
	C.print('A * B');
	A.done;
	B.done;
	C.done;
end;

begin
	clrscr;
	writeln('⢥ ');
	test_real;
	write(' <Enter>');
	readln;
	clrscr;
	writeln('樮 ');
	test_rational;
	write(' <Enter>');
	readln;
	clrscr;
	writeln(' ');
	test_complex;
	write(' <Enter>');
	readln;
end.
